unit n2_matrix;

interface

uses n2_complex,n2_vector;

type tmatrix=array of array of double;
	 tmatrixc=array of array of tcomplex;

function initm(sy,sx:longint):tmatrix;
function initmc(sy,sx:longint):tmatrixc;
function det(m:tmatrix):double;
function det(m:tmatrixc):tcomplex;
function trans(m:tmatrix):tmatrix;
function trans(m:tmatrixc):tmatrixc;
function addm(m1,m2:tmatrix):tmatrix;
function addm(m1:tmatrix;m2:tmatrixc):tmatrixc;
function addm(m1:tmatrixc;m2:tmatrix):tmatrixc;
function addm(m1,m2:tmatrixc):tmatrixc;
function subm(m1,m2:tmatrix):tmatrix;
function subm(m1:tmatrix;m2:tmatrixc):tmatrixc;
function subm(m1:tmatrixc;m2:tmatrix):tmatrixc;
function subm(m1,m2:tmatrixc):tmatrixc;
function mulm(s:double;m:tmatrix):tmatrix;
function mulm(m:tmatrix;s:double):tmatrix;
function mulm(s:double;m:tmatrixc):tmatrixc;
function mulm(m:tmatrixc;s:double):tmatrixc;
function mulm(s:tcomplex;m:tmatrix):tmatrixc;
function mulm(m:tmatrix;s:tcomplex):tmatrixc;
function mulm(s:tcomplex;m:tmatrixc):tmatrixc;
function mulm(m:tmatrixc;s:tcomplex):tmatrixc;
function mulm(m1,m2:tmatrix):tmatrix;
function mulm(m1:tmatrix;m2:tmatrixc):tmatrixc;
function mulm(m1:tmatrixc;m2:tmatrix):tmatrixc;
function mulm(m1,m2:tmatrixc):tmatrixc;
function invm(m:tmatrix):tmatrix;
function invm(m:tmatrixc):tmatrixc;
function solve(m,eq:tmatrix):tmatrix;
function solve(m:tmatrix;eq:tmatrixc):tmatrixc;
function solve(m:tmatrixc;eq:tmatrix):tmatrixc;
function solve(m,eq:tmatrixc):tmatrixc;
function solve(m:tmatrix;eq:tvector):tvector;
function solve(m:tmatrix;eq:tvectorc):tvectorc;
function solve(m:tmatrixc;eq:tvector):tvectorc;
function solve(m:tmatrixc;eq:tvectorc):tvectorc;
function crossm(m:tmatrix):tvector;
function crossm(m:tmatrixc):tvectorc;

implementation

uses n2_mathe;

function initm(sy,sx:longint):tmatrix;
var mi:tmatrix;
begin
  setlength(mi,sy,sx);
  initm:=mi;
end;

function initmc(sy,sx:longint):tmatrixc;
var mi:tmatrixc;
begin
  setlength(mi,sy,sx);
  initmc:=mi;
end;

function det(m:tmatrix):double;
var s,dmi:double;
	i,j,k:longint;
	mi:tmatrix;
begin
  if length(m)=length(m[0]) then
  begin
    if length(m)=1 then det:=m[0,0]
	else
	begin
	  mi:=initm(length(m)-1,length(m[0])-1);
      s:=0;
	  for k:=0 to length(m[0])-1 do
	  begin
	    for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j+1,i+byte(i>=k)];
		dmi:=det(mi);
	    s:=s-2*(k mod 2-0.5)*m[0,k]*dmi;
	  end;
	  det:=s;
	end;
  end
  else writeln('det: square matrices only.');
end;

function det(m:tmatrixc):tcomplex;
var s,dmi:tcomplex;
	i,j,k:longint;
	mi:tmatrixc;
begin
  if length(m)=length(m[0]) then
  begin
    if length(m)=1 then det:=m[0,0]
	else
	begin
	  mi:=initmc(length(m)-1,length(m[0])-1);
      s:=setc(0,0);
	  for k:=0 to length(m[0])-1 do
	  begin
	    for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j+1,i+byte(i>=k)];
		dmi:=det(mi);
	    s:=addc(s,mulc(-2*(k mod 2-0.5),mulc(m[0,k],dmi)));
	  end;
	  det:=s;
	end;
  end
  else writeln('det: square matrices only.');
end;

function trans(m:tmatrix):tmatrix;
var mi:tmatrix;
	i,j:longint;
begin
  mi:=initm(length(m[0]),length(m));
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[i,j];
  trans:=mi;
end;

function trans(m:tmatrixc):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  mi:=initmc(length(m[0]),length(m));
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[i,j];
  trans:=mi;
end;

function addm(m1,m2:tmatrix):tmatrix;
var mi:tmatrix;
	i,j:longint;
begin
  if (length(m1)=length(m2)) and (length(m1[0])=length(m2[0])) then
  begin
    mi:=initm(length(m1),length(m1[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m1[j,i]+m2[j,i];
	addm:=mi;
  end
  else writeln('addm: matrices of same size only.');
end;

function addm(m1:tmatrix;m2:tmatrixc):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  if (length(m1)=length(m2)) and (length(m1[0])=length(m2[0])) then
  begin
    mi:=initmc(length(m1),length(m1[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=addc(m1[j,i],m2[j,i]);
	addm:=mi;
  end
  else writeln('addm: matrices of same size only.');
end;

function addm(m1:tmatrixc;m2:tmatrix):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  if (length(m1)=length(m2)) and (length(m1[0])=length(m2[0])) then
  begin
    mi:=initmc(length(m1),length(m1[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=addc(m1[j,i],m2[j,i]);
	addm:=mi;
  end
  else writeln('addm: matrices of same size only.');
end;

function addm(m1,m2:tmatrixc):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  if (length(m1)=length(m2)) and (length(m1[0])=length(m2[0])) then
  begin
    mi:=initmc(length(m1),length(m1[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=addc(m1[j,i],m2[j,i]);
	addm:=mi;
  end
  else writeln('addm: matrices of same size only.');
end;

function subm(m1,m2:tmatrix):tmatrix;
var mi:tmatrix;
	i,j:longint;
begin
  if (length(m1)=length(m2)) and (length(m1[0])=length(m2[0])) then
  begin
    mi:=initm(length(m1),length(m1[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m1[j,i]-m2[j,i];
	subm:=mi;
  end
  else writeln('subm: matrices of same size only.');
end;

function subm(m1:tmatrix;m2:tmatrixc):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  if (length(m1)=length(m2)) and (length(m1[0])=length(m2[0])) then
  begin
    mi:=initmc(length(m1),length(m1[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=subc(m1[j,i],m2[j,i]);
	subm:=mi;
  end
  else writeln('subm: matrices of same size only.');
end;

function subm(m1:tmatrixc;m2:tmatrix):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  if (length(m1)=length(m2)) and (length(m1[0])=length(m2[0])) then
  begin
    mi:=initmc(length(m1),length(m1[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=subc(m1[j,i],m2[j,i]);
	subm:=mi;
  end
  else writeln('subm: matrices of same size only.');
end;

function subm(m1,m2:tmatrixc):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  if (length(m1)=length(m2)) and (length(m1[0])=length(m2[0])) then
  begin
    mi:=initmc(length(m1),length(m1[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=subc(m1[j,i],m2[j,i]);
	subm:=mi;
  end
  else writeln('subm: matrices of same size only.');
end;

function mulm(s:double;m:tmatrix):tmatrix;
var mi:tmatrix;
	i,j:longint;
begin
  mi:=initm(length(m),length(m[0])); 
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=s*m[j,i];
  mulm:=mi;
end;

function mulm(m:tmatrix;s:double):tmatrix;
var mi:tmatrix;
	i,j:longint;
begin
  mi:=initm(length(m),length(m[0])); 
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i]*s;
  mulm:=mi;
end;

function mulm(s:double;m:tmatrixc):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  mi:=initmc(length(m),length(m[0])); 
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=mulc(s,m[j,i]);
  mulm:=mi;
end;

function mulm(m:tmatrixc;s:double):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  mi:=initmc(length(m),length(m[0])); 
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=mulc(m[j,i],s);
  mulm:=mi;
end;

function mulm(s:tcomplex;m:tmatrix):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  mi:=initmc(length(m),length(m[0])); 
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=mulc(s,m[j,i]);
  mulm:=mi;
end;

function mulm(m:tmatrix;s:tcomplex):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  mi:=initmc(length(m),length(m[0])); 
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=mulc(m[j,i],s);
  mulm:=mi;
end;

function mulm(s:tcomplex;m:tmatrixc):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  mi:=initmc(length(m),length(m[0])); 
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=mulc(s,m[j,i]);
  mulm:=mi;
end;

function mulm(m:tmatrixc;s:tcomplex):tmatrixc;
var mi:tmatrixc;
	i,j:longint;
begin
  mi:=initmc(length(m),length(m[0])); 
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=mulc(m[j,i],s);
  mulm:=mi;
end;

function mulm(m1,m2:tmatrix):tmatrix;
var mi:tmatrix;
	i,j,k:longint;
begin
  if length(m1[0])=length(m2) then
  begin
    mi:=initm(length(m1),length(m2[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do 
	begin
	  mi[j,i]:=0;
	  for k:=0 to length(m1[0])-1 do mi[j,i]:=mi[j,i]+m1[j,k]*m2[k,i];
	end;
	mulm:=mi;
  end
  else writeln('mulm: matrices of same inner dimension only.');
end;

function mulm(m1:tmatrix;m2:tmatrixc):tmatrixc;
var mi:tmatrixc;
	i,j,k:longint;
begin
  if length(m1[0])=length(m2) then
  begin
    mi:=initmc(length(m1),length(m2[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do 
	begin
	  mi[j,i]:=setc(0,0);
	  for k:=0 to length(m1[0])-1 do mi[j,i]:=addc(mi[j,i],mulc(m1[j,k],m2[k,i]));
	end;
	mulm:=mi;
  end
  else writeln('mulm: matrices of same inner dimension only.');
end;

function mulm(m1:tmatrixc;m2:tmatrix):tmatrixc;
var mi:tmatrixc;
	i,j,k:longint;
begin
  if length(m1[0])=length(m2) then
  begin
    mi:=initmc(length(m1),length(m2[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do 
	begin
	  mi[j,i]:=setc(0,0);
	  for k:=0 to length(m1[0])-1 do mi[j,i]:=addc(mi[j,i],mulc(m1[j,k],m2[k,i]));
	end;
	mulm:=mi;
  end
  else writeln('mulm: matrices of same inner dimension only.');
end;

function mulm(m1,m2:tmatrixc):tmatrixc;
var mi:tmatrixc;
	i,j,k:longint;
begin
  if length(m1[0])=length(m2) then
  begin
    mi:=initmc(length(m1),length(m2[0])); 
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do 
	begin
	  mi[j,i]:=setc(0,0);
	  for k:=0 to length(m1[0])-1 do mi[j,i]:=addc(mi[j,i],mulc(m1[j,k],m2[k,i]));
	end;
	mulm:=mi;
  end
  else writeln('mulm: matrices of same inner dimension only.');
end;

function invm(m:tmatrix):tmatrix;
var mi,mo:tmatrix;
	i,j,k:longint;
	d:double;
begin
  if length(m)=length(m[0]) then
  begin
    mo:=initm(length(m),length(m[0]));
	mi:=initm(length(m),length(m[0]));
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
	for j:=0 to length(mo)-1 do for i:=0 to length(mo[0])-1 do mo[j,i]:=byte(i=j);
	for k:=0 to length(mi)-1 do
	begin
	  d:=1/mi[k,k];
	  for i:=k to length(mi[0])-1 do mi[k,i]:=mi[k,i]*d;
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mo[k,i]*d;
	  for j:=k+1 to length(mi)-1 do
	  begin
		d:=-mi[j,k];
		for i:=0 to k-1 do mo[j,i]:=mo[j,i]+mo[k,i]*d;
		for i:=k to length(mi[0])-1 do 
		begin
		  mi[j,i]:=mi[j,i]+mi[k,i]*d;
		  mo[j,i]:=mo[j,i]+mo[k,i]*d;
		end;
	  end;
	end;
	for k:=length(mi)-1 downto 0 do
	begin
	  d:=1/mi[k,k];
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mo[k,i]*d;
	  for j:=k-1 downto 0 do
	  begin
		d:=-mi[j,k];
		for i:=0 to length(mi[0])-1 do mo[j,i]:=mo[j,i]+mo[k,i]*d;
	  end;
	end;
    invm:=mo;
  end
  else writeln('invm: square matrices only.');
end;

function invm(m:tmatrixc):tmatrixc;
var mi,mo:tmatrixc;
	i,j,k:longint;
	c:tcomplex;
begin
  if length(m)=length(m[0]) then
  begin
    mo:=initmc(length(m),length(m[0]));
	mi:=initmc(length(m),length(m[0]));
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
	for j:=0 to length(mo)-1 do for i:=0 to length(mo[0])-1 do mo[j,i]:=setc(byte(i=j),0);
	for k:=0 to length(mi)-1 do
	begin
	  c:=invc(mi[k,k]);
	  for i:=k to length(mi[0])-1 do mi[k,i]:=mulc(mi[k,i],c);
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mulc(mo[k,i],c);
	  for j:=k+1 to length(mi)-1 do
	  begin
		c:=mulc(-1,mi[j,k]);
		for i:=0 to k-1 do mo[j,i]:=addc(mo[j,i],mulc(mo[k,i],c));
		for i:=k to length(mi[0])-1 do 
		begin
		  mi[j,i]:=addc(mi[j,i],mulc(mi[k,i],c));
		  mo[j,i]:=addc(mo[j,i],mulc(mo[k,i],c));
		end;
	  end;
	end;
	for k:=length(mi)-1 downto 0 do
	begin
	  c:=invc(mi[k,k]);
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mulc(mo[k,i],c);
	  for j:=k-1 downto 0 do
	  begin
		c:=mulc(-1,mi[j,k]);
		for i:=0 to length(mi[0])-1 do mo[j,i]:=addc(mo[j,i],mulc(mo[k,i],c));
	  end;
	end;
    invm:=mo;
  end
  else writeln('invm: square matrices only.');
end;

function solve(m,eq:tmatrix):tmatrix;
var mi,mo:tmatrix;
	i,j,k:longint;
	d:double;
begin
  if (length(m)=length(m[0])) and (length(m[0])=length(eq)) then
  begin
    mo:=initm(length(eq),length(eq[0]));
	mi:=initm(length(m),length(m[0]));
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
	for j:=0 to length(mo)-1 do for i:=0 to length(mo[0])-1 do mo[j,i]:=eq[j,i];
	for k:=0 to length(mi)-1 do
	begin
	  d:=1/mi[k,k];
	  for i:=k to length(mi[0])-1 do mi[k,i]:=mi[k,i]*d;
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mo[k,i]*d;
	  for j:=k+1 to length(mi)-1 do
	  begin
		d:=-mi[j,k];
		for i:=k to length(mi[0])-1 do mi[j,i]:=mi[j,i]+mi[k,i]*d;
		for i:=0 to length(mo[0])-1 do mo[j,i]:=mo[j,i]+mo[k,i]*d;
	  end;
	end;
	for k:=length(mi)-1 downto 0 do
	begin
	  d:=1/mi[k,k];
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mo[k,i]*d;
	  for j:=k-1 downto 0 do
	  begin
		d:=-mi[j,k];
		for i:=0 to length(mo[0])-1 do mo[j,i]:=mo[j,i]+mo[k,i]*d;
	  end;
	end;
    solve:=mo;
  end
  else writeln('solve: square matrix and solution of same inner dimension only.');
end;

function solve(m:tmatrix;eq:tmatrixc):tmatrixc;
var mi:tmatrix;
    mo:tmatrixc;
	i,j,k:longint;
	d:double;
begin
  if (length(m)=length(m[0])) and (length(m[0])=length(eq)) then
  begin
    mo:=initmc(length(eq),length(eq[0]));
	mi:=initm(length(m),length(m[0]));
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
	for j:=0 to length(mo)-1 do for i:=0 to length(mo[0])-1 do mo[j,i]:=eq[j,i];
	for k:=0 to length(mi)-1 do
	begin
	  d:=1/mi[k,k];
	  for i:=k to length(mi[0])-1 do mi[k,i]:=mi[k,i]*d;
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mulc(mo[k,i],d);
	  for j:=k+1 to length(mi)-1 do
	  begin
		d:=-mi[j,k];
		for i:=k to length(mi[0])-1 do mi[j,i]:=mi[j,i]+mi[k,i]*d;
		for i:=0 to length(mo[0])-1 do mo[j,i]:=addc(mo[j,i],mulc(mo[k,i],d));
	  end;
	end;
	for k:=length(mi)-1 downto 0 do
	begin
	  d:=1/mi[k,k];
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mulc(mo[k,i],d);
	  for j:=k-1 downto 0 do
	  begin
		d:=-mi[j,k];
		for i:=0 to length(mo[0])-1 do mo[j,i]:=addc(mo[j,i],mulc(mo[k,i],d));
	  end;
	end;
    solve:=mo;
  end
  else writeln('solve: square matrix and solution of same inner dimension only.');
end;

function solve(m:tmatrixc;eq:tmatrix):tmatrixc;
var mi,mo:tmatrixc;
	i,j,k:longint;
	c:tcomplex;
begin
  if (length(m)=length(m[0])) and (length(m[0])=length(eq)) then
  begin
    mo:=initmc(length(eq),length(eq[0]));
	mi:=initmc(length(m),length(m[0]));
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
	for j:=0 to length(mo)-1 do for i:=0 to length(mo[0])-1 do mo[j,i]:=setc(eq[j,i],0);
	for k:=0 to length(mi)-1 do
	begin
	  c:=invc(mi[k,k]);
	  for i:=k to length(mi[0])-1 do mi[k,i]:=mulc(mi[k,i],c);
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mulc(mo[k,i],c);
	  for j:=k+1 to length(mi)-1 do
	  begin
		c:=mulc(-1,mi[j,k]);
		for i:=k to length(mi[0])-1 do mi[j,i]:=addc(mi[j,i],mulc(mi[k,i],c));
		for i:=0 to length(mo[0])-1 do mo[j,i]:=addc(mo[j,i],mulc(mo[k,i],c));
	  end;
	end;
	for k:=length(mi)-1 downto 0 do
	begin
	  c:=invc(mi[k,k]);
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mulc(mo[k,i],c);
	  for j:=k-1 downto 0 do
	  begin
		c:=mulc(-1,mi[j,k]);
		for i:=0 to length(mo[0])-1 do mo[j,i]:=addc(mo[j,i],mulc(mo[k,i],c));
	  end;
	end;
    solve:=mo;
  end
  else writeln('solve: square matrix and solution of same inner dimension only.');
end;

function solve(m,eq:tmatrixc):tmatrixc;
var mi,mo:tmatrixc;
	i,j,k:longint;
	c:tcomplex;
begin
  if (length(m)=length(m[0])) and (length(m[0])=length(eq)) then
  begin
    mo:=initmc(length(eq),length(eq[0]));
	mi:=initmc(length(m),length(m[0]));
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
	for j:=0 to length(mo)-1 do for i:=0 to length(mo[0])-1 do mo[j,i]:=eq[j,i];
	for k:=0 to length(mi)-1 do
	begin
	  c:=invc(mi[k,k]);
	  for i:=k to length(mi[0])-1 do mi[k,i]:=mulc(mi[k,i],c);
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mulc(mo[k,i],c);
	  for j:=k+1 to length(mi)-1 do
	  begin
		c:=mulc(-1,mi[j,k]);
		for i:=k to length(mi[0])-1 do mi[j,i]:=addc(mi[j,i],mulc(mi[k,i],c));
		for i:=0 to length(mo[0])-1 do mo[j,i]:=addc(mo[j,i],mulc(mo[k,i],c));
	  end;
	end;
	for k:=length(mi)-1 downto 0 do
	begin
	  c:=invc(mi[k,k]);
	  for i:=0 to length(mo[0])-1 do mo[k,i]:=mulc(mo[k,i],c);
	  for j:=k-1 downto 0 do
	  begin
		c:=mulc(-1,mi[j,k]);
		for i:=0 to length(mo[0])-1 do mo[j,i]:=addc(mo[j,i],mulc(mo[k,i],c));
	  end;
	end;
    solve:=mo;
  end
  else writeln('solve: square matrix and solution of same inner dimension only.');
end;


function solve(m:tmatrix;eq:tvector):tvector;
var mi:tmatrix;
	vo:tvector;
	i,j,k:longint;
	d:double;
begin
  if (length(m)=length(m[0])) and (length(m[0])=length(eq)) then
  begin
    vo:=initv(length(eq));
	mi:=initm(length(m),length(m[0]));
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
	for i:=0 to length(vo)-1 do vo[i]:=eq[i];
	for k:=0 to length(mi)-1 do
	begin
	  d:=1/mi[k,k];
	  for i:=k to length(mi[0])-1 do mi[k,i]:=mi[k,i]*d;
	  vo[k]:=vo[k]*d;
	  for j:=k+1 to length(mi)-1 do
	  begin
		d:=-mi[j,k];
		for i:=k to length(mi[0])-1 do mi[j,i]:=mi[j,i]+mi[k,i]*d;
		vo[j]:=vo[j]+vo[k]*d;
	  end;
	end;
	for k:=length(mi)-1 downto 0 do
	begin
	  d:=1/mi[k,k];
	  vo[k]:=vo[k]*d;
	  for j:=k-1 downto 0 do
	  begin
		d:=-mi[j,k];
		vo[j]:=vo[j]+vo[k]*d;
	  end;
	end;
    solve:=vo;
  end
  else writeln('solve: square matrix and solution of same inner dimension only.');
end;

function solve(m:tmatrix;eq:tvectorc):tvectorc;
var mi:tmatrix;
	vo:tvectorc;
	i,j,k:longint;
	d:double;
begin
  if (length(m)=length(m[0])) and (length(m[0])=length(eq)) then
  begin
    vo:=initvc(length(eq));
	mi:=initm(length(m),length(m[0]));
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
	for i:=0 to length(vo)-1 do vo[i]:=eq[i];
	for k:=0 to length(mi)-1 do
	begin
	  d:=1/mi[k,k];
	  for i:=k to length(mi[0])-1 do mi[k,i]:=mi[k,i]*d;
	  vo[k]:=mulc(vo[k],d);
	  for j:=k+1 to length(mi)-1 do
	  begin
		d:=-mi[j,k];
		for i:=k to length(mi[0])-1 do mi[j,i]:=mi[j,i]+mi[k,i]*d;
		vo[j]:=addc(vo[j],mulc(vo[k],d));
	  end;
	end;
	for k:=length(mi)-1 downto 0 do
	begin
	  d:=1/mi[k,k];
	  vo[k]:=mulc(vo[k],d);
	  for j:=k-1 downto 0 do
	  begin
		d:=-mi[j,k];
		vo[j]:=addc(vo[j],mulc(vo[k],d));
	  end;
	end;
    solve:=vo;
  end
  else writeln('solve: square matrix and solution of same inner dimension only.');
end;

function solve(m:tmatrixc;eq:tvector):tvectorc;
var mi:tmatrixc;
	vo:tvectorc;
	i,j,k:longint;
	c:tcomplex;
begin
  if (length(m)=length(m[0])) and (length(m[0])=length(eq)) then
  begin
    vo:=initvc(length(eq));
	mi:=initmc(length(m),length(m[0]));
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
	for i:=0 to length(vo)-1 do vo[i]:=setc(eq[i],0);
	for k:=0 to length(mi)-1 do
	begin
	  c:=invc(mi[k,k]);
	  for i:=k to length(mi[0])-1 do mi[k,i]:=mulc(mi[k,i],c);
	  vo[k]:=mulc(vo[k],c);
	  for j:=k+1 to length(mi)-1 do
	  begin
		c:=mulc(-1,mi[j,k]);
		for i:=k to length(mi[0])-1 do mi[j,i]:=addc(mi[j,i],mulc(mi[k,i],c));
		vo[j]:=addc(vo[j],mulc(vo[k],c));
	  end;
	end;
	for k:=length(mi)-1 downto 0 do
	begin
	  c:=invc(mi[k,k]);
	  vo[k]:=mulc(vo[k],c);
	  for j:=k-1 downto 0 do
	  begin
		c:=mulc(-1,mi[j,k]);
		vo[j]:=addc(vo[j],mulc(vo[k],c));
	  end;
	end;
    solve:=vo;
  end
  else writeln('solve: square matrix and solution of same inner dimension only.');
end;

function solve(m:tmatrixc;eq:tvectorc):tvectorc;
var mi:tmatrixc;
	vo:tvectorc;
	i,j,k:longint;
	c:tcomplex;
begin
  if (length(m)=length(m[0])) and (length(m[0])=length(eq)) then
  begin
    vo:=initvc(length(eq));
	mi:=initmc(length(m),length(m[0]));
	for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
	for i:=0 to length(vo)-1 do vo[i]:=eq[i];
	for k:=0 to length(mi)-1 do
	begin
	  c:=invc(mi[k,k]);
	  for i:=k to length(mi[0])-1 do mi[k,i]:=mulc(mi[k,i],c);
	  vo[k]:=mulc(vo[k],c);
	  for j:=k+1 to length(mi)-1 do
	  begin
		c:=mulc(-1,mi[j,k]);
		for i:=k to length(mi[0])-1 do mi[j,i]:=addc(mi[j,i],mulc(mi[k,i],c));
		vo[j]:=addc(vo[j],mulc(vo[k],c));
	  end;
	end;
	for k:=length(mi)-1 downto 0 do
	begin
	  c:=invc(mi[k,k]);
	  vo[k]:=mulc(vo[k],c);
	  for j:=k-1 downto 0 do
	  begin
		c:=mulc(-1,mi[j,k]);
		vo[j]:=addc(vo[j],mulc(vo[k],c));
	  end;
	end;
    solve:=vo;
  end
  else writeln('solve: square matrix and solution of same inner dimension only.');
end;

function crossm(m:tmatrix):tvector;
var i,j,k:longint;
	vo:tvector;
	mi:tmatrix;
begin
  if length(m)=length(m[0])-1 then
  begin
	vo:=initv(length(m[0]));
	mi:=initm(length(m),length(m[0])-1);
	for k:=0 to length(vo)-1 do
	begin
	  for j:=0 to length(vo)-2 do for i:=0 to length(vo)-2 do mi[j,i]:=m[j,i+byte(i>=k)];
	  vo[k]:=-sgn(k mod 2-0.5)*sgn(length(vo) mod 2-0.5)*det(mi);
	end;
	crossm:=vo;
  end
  else
  begin
	if length(m)-1=length(m[0]) then
	begin
	  vo:=initv(length(m));
	  mi:=initm(length(m)-1,length(m[0]));
	  for k:=0 to length(vo)-1 do
	  begin
	    for j:=0 to length(vo)-2 do for i:=0 to length(vo)-2 do mi[j,i]:=m[j+byte(j>=k),i];
		vo[k]:=-sgn(k mod 2-0.5)*sgn(length(vo) mod 2-0.5)*det(mi);
	  end;
	  crossm:=vo;
	end
	else writeln('cross: for matrices with n*(n-1) or (n-1)*n elements only.');
  end;
end;

function crossm(m:tmatrixc):tvectorc;
begin
end;

end.